/****** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Initial Developer of the Original Code is Eelco van Kuik.
   -
   - Contributor(s):
   - Several developers
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK *****/


var nsHistory = {
	//History.rdf datasource
	ds		: null,
	
	//log.rdf datasource
	dsLog	: null,
	
	/**
	*	This routine adds the search terms to the history
	*/
	init : function () {
		var aUri = 'file:///' + nsRdfLocator.getHistory(true);
		document.getElementById('NeedleSearchSearchTermsPopup').datasources = aUri;
		nsHistory.ds	= new nsRdfds.RDFDataSource(aUri);
		
		//Init the logfile
		var aLogUri = 'file:///' + nsRdfLocator.getLog(true);
		nsHistory.dsLog = new nsRdfds.RDFDataSource(aLogUri);
	},
	
	/**
	*	This routine adds the search terms to the history
	*/
	add : function (searchengineID, searchengine, searchterms) {
		
		if ( searchterms.replace(/\s+/, '').length == 0 ) {
			return
		}
		
		//Add to history list
		var rootNode = nsHistory.ds.getNode(nsRdfds.historyURI) ;
		var children	=	rootNode.getChildren()
		var child, aVal, n = 0
		
		//Filter out the doubles
		while ( children.hasMoreElements() ) {
			child = children.getNext()
			aVal = child.getTarget(nsRdfds.aXMLPath + "searchterms")
			if ( aVal ) {
				if ( n < 25 ) {
					aVal = aVal.getValue()
					if (aVal == searchterms) {
						child.removeTarget( nsRdfds.aXMLPath + "searchterms", aVal )
					}
				} else {
					child.removeTarget( nsRdfds.aXMLPath + "searchterms", aVal )
					rootNode.removeChild( child );
				}
			} else {
				rootNode.removeChild( child );
			}
			n++;
		}

		//Now insert it at the top
		var newNode = nsHistory.ds.getAnonymousNode();
		newNode = rootNode.addChildAt(newNode, 1)
		newNode.addTarget(nsRdfds.aXMLPath + "searchterms", searchterms);
		nsHistory.ds.save();
		
		//Now add it to the log as well
		
		var rootLogNode = nsHistory.dsLog.getNode( nsRdfds.logURI ) ;
		
		//Now insert new entry at the top
		var newLogNode = nsHistory.dsLog.getAnonymousNode();
		rootLogNode.addChildAt(newLogNode, 1)
		
		newLogNode.addTarget(nsRdfds.aXMLPath + "searchengineID", searchengineID);
		newLogNode.addTarget(nsRdfds.aXMLPath + "searchengine", searchengine);
		newLogNode.addTarget(nsRdfds.aXMLPath + "searchterms", searchterms);
		var d = new Date()
		
		var minutes	= d.getMinutes().toString()
		minutes		= (( minutes.length == 1) ? '0' + minutes : minutes)
		var seconds	= d.getSeconds().toString()
		seconds		= (( seconds.length == 1 ) ? '0' + seconds : seconds)
		var hours	= d.getHours()
		hours		= (( hours.length == 1 ) ? ' ' + hours : hours)
		var month	= d.getMonth() + 1
		month		= (( month.length == 1 ) ? ' ' + month : month)
		var days	= d.getDate()
		days		= (( days.length == 1 ) ? ' ' + days : days)
		
		var aDate = d.getFullYear() + '-' + month + '-' + days + ' ' + hours + ':' + minutes + ':' + seconds
		newLogNode.addTarget(nsRdfds.aXMLPath + "datetime", aDate );
		
		nsHistory.dsLog.save();
		
	},
	/*
	 * Clears the list of searchterms
	 */
	clear	: function () {
		
		var rootNode = nsHistory.ds.getNode(nsRdfds.historyURI) ;
		var children	=	rootNode.getChildren()
		var child, aVal, n = 0
		
		while ( children.hasMoreElements() ) {
			child = children.getNext()
			//aVal = child.getTarget(nsRdfds.aXMLPath + "searchterms")
			//child.removeTarget( nsRdfds.aXMLPath + "searchterms", aVal )
			nsHistory.ds.deleteRecursive( child );
		}
		
	}


}